<template>
  <Dialog :title="dialogTitle" v-model="dialogVisible">
    <el-form
      ref="formRef"
      :model="formData"
      :rules="formRules"
      label-width="100px"
      v-loading="formLoading"
    >
      <el-form-item label="巷道id" prop="streetId">
        <el-input v-model="formData.streetId" placeholder="请输入巷道id" />
      </el-form-item>
      <el-form-item label="ip" prop="ip">
        <el-input v-model="formData.ip" placeholder="请输入ip" />
      </el-form-item>
      <el-form-item label="端口" prop="port">
        <el-input v-model="formData.port" placeholder="请输入端口" />
      </el-form-item>
      <el-form-item label="方向 " prop="direction">
        <el-select v-model="formData.direction" placeholder="请选择方向 ">
          <el-option
            v-for="dict in getIntDictOptions(DICT_TYPE.DIRECTION)"
            :key="dict.value"
            :label="dict.label"
            :value="dict.value"
          />
        </el-select>
      </el-form-item>
      <el-form-item label="信息" prop="info">
        <el-input v-model="formData.info" placeholder="请输入信息" />
      </el-form-item>
      <el-form-item label="类型" prop="type">
        <el-select v-model="formData.type" placeholder="请选择类型">
          <el-option
            v-for="dict in getIntDictOptions(DICT_TYPE.LIGHT_TYPE)"
            :key="dict.value"
            :label="dict.label"
            :value="dict.value"
          />
        </el-select>
      </el-form-item>
    </el-form>
    <template #footer>
      <el-button @click="submitForm" type="primary" :disabled="formLoading">确 定</el-button>
      <el-button @click="dialogVisible = false">取 消</el-button>
    </template>
  </Dialog>
</template>
<script setup lang="ts">
import { getIntDictOptions, DICT_TYPE } from '@/utils/dict'
import { LightSourceApi, LightSourceVO } from '@/api/logistics/lightsource'

/** 光源 表单 */
defineOptions({ name: 'LightSourceForm' })

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({
  id: undefined,
  streetId: undefined,
  ip: undefined,
  port: undefined,
  direction: undefined,
  info: undefined,
  type: undefined,
})
const formRules = reactive({
  streetId: [{ required: true, message: '巷道id不能为空', trigger: 'blur' }],
})
const formRef = ref() // 表单 Ref

/** 打开弹窗 */
const open = async (type: string, id?: number) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await LightSourceApi.getLightSource(id)
    } finally {
      formLoading.value = false
    }
  }
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  await formRef.value.validate()
  // 提交请求
  formLoading.value = true
  try {
    const data = formData.value as unknown as LightSourceVO
    if (formType.value === 'create') {
      await LightSourceApi.createLightSource(data)
      message.success(t('common.createSuccess'))
    } else {
      await LightSourceApi.updateLightSource(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    id: undefined,
    streetId: undefined,
    ip: undefined,
    port: undefined,
    direction: undefined,
    info: undefined,
    type: undefined,
  }
  formRef.value?.resetFields()
}
</script>